{-# LANGUAGE FlexibleContexts, TemplateHaskell, TypeFamilies, ScopedTypeVariables, ViewPatterns #-}
module EdgeBX where
import Generics.BiGUL
import Generics.BiGUL.Interpreter
import Generics.BiGUL.TH
import Generics.BiGUL.Lib
import Generics.BiGUL.Lib.List
import Data.List
import Data.Maybe
import GHC.Generics
import Debug.Trace
import JsonFormat
import PRBAC
import PolicyAlign
import System.IO  
import Control.Monad
import Text.Regex
import Control.Exception
import Data.Time


polexample :: Policy
polexample = Pol (Rol "lab") (DP ("Write","labs")) (Pur "MedicalCare") (Con (("LabDateTime",""),"NEqual")) (ONull)


--()    <- rnf bis
--getClockTime >>= putStrLn . show

getview_time = do
        handle <- openFile "10k-Patients-20k-labs.json" ReadMode
        contents <- hGetContents handle
        let wordslist = words contents
        let str = concat wordslist
        let bis = paserobject str
        evaluate $  bis
        start <- getCurrentTime
        let biv = fromJust $ get (policysyn polexample) bis
        evaluate $  biv
        end <- getCurrentTime
        print (diffUTCTime end start)

getview = do  
        handle <- openFile "10k-Patients-20k-labs.json" ReadMode
        contents <- hGetContents handle
        let wordslist = words contents
        let str = concat wordslist
        let bis = paserobject str
        let biv = fromJust $ get (policysyn polexample) bis
        writeFile "view.json" (showobject biv 0)
        writeFile "result.txt" "this is the source json:\n"
        appendFile "result.txt" (showobject bis 0)
        appendFile "result.txt" "\n\nthis is the view json:\n"
        appendFile "result.txt" (showobject biv 0)
        hClose handle

updatesource = do  
        handle <- openFile "source.json" ReadMode
        contents <- hGetContents handle
        let wordslist = words contents
            str = concat wordslist
        let bis = paserobject str
        handle <- openFile "view.json" ReadMode
        contents <- hGetContents handle
        let wordslist = words contents
            str = concat wordslist
        let biv = paserobject str
        let biss = fromJust $ put (policysyn polexample) bis biv
        writeFile "source_new.json" (showobject biss 0)
        writeFile "result.txt" "this is the source json:\n"
        appendFile "result.txt" (showobject bis 0)
        appendFile "result.txt" "\n\nthis is the view json:\n"
        appendFile "result.txt" (showobject biv 0)
        appendFile "result.txt" "\n\nthis is the new source json:\n"
        appendFile "result.txt" (showobject biss 0)
        hClose handle
